package org.openxma.dsl.reference.dto;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import org.openxma.dsl.reference.dto.OrderItemView;
import org.openxma.dsl.reference.dto.OrderView;
import org.openxma.dsl.reference.types.valueobject.OrderNumber;

public abstract class OrderViewGen implements Serializable {
	private static final long serialVersionUID = -591413451;
	protected List<OrderView> orders;
	protected List<OrderItemView> orderItems;
	protected String oid;
	protected Date version;
	protected OrderNumber orderNumber;
	protected String storeId;
	protected Date placementDate;
	protected Date deliveryDate;
	protected String orderState;
	protected Integer taxes;
	protected Double totalAmount;
	protected String customerOid;
	
	public List<OrderView> getOrders() {
        return this.orders;
    }
	
	public void setOrders(List<OrderView> orders) {
        this.orders=orders;
    }
    
    public void addOrders(OrderView orders) {
		if (orders == null) {
			throw new IllegalArgumentException("parameter 'orders' must not be null");
		}
		if (getOrders() == null) {
			this.orders = new ArrayList<OrderView>();
		}
		this.orders.add(orders);
	}
	
	public List<OrderItemView> getOrderItems() {
        return this.orderItems;
    }
	
	public void setOrderItems(List<OrderItemView> orderItems) {
        this.orderItems=orderItems;
    }
    
    public void addOrderItems(OrderItemView orderItems) {
		if (orderItems == null) {
			throw new IllegalArgumentException("parameter 'orderItems' must not be null");
		}
		if (getOrderItems() == null) {
			this.orderItems = new ArrayList<OrderItemView>();
		}
		this.orderItems.add(orderItems);
	}
	
	public String getOid() {
        return this.oid;
    }
	
	public void setOid(String oid) {
        this.oid=oid;
    }
	
	public Date getVersion() {
        return this.version;
    }
	
	public void setVersion(Date version) {
        this.version=version;
    }
	
	public OrderNumber getOrderNumber() {
        return this.orderNumber;
    }
	
	public void setOrderNumber(OrderNumber orderNumber) {
        this.orderNumber=orderNumber;
    }
	
	public String getStoreId() {
        return this.storeId;
    }
	
	public void setStoreId(String storeId) {
        this.storeId=storeId;
    }
	
	public Date getPlacementDate() {
        return this.placementDate;
    }
	
	public void setPlacementDate(Date placementDate) {
        this.placementDate=placementDate;
    }
	
	public Date getDeliveryDate() {
        return this.deliveryDate;
    }
	
	public void setDeliveryDate(Date deliveryDate) {
        this.deliveryDate=deliveryDate;
    }
	
	public String getOrderState() {
        return this.orderState;
    }
	
	public void setOrderState(String orderState) {
        this.orderState=orderState;
    }
	
	public Integer getTaxes() {
        return this.taxes;
    }
	
	public void setTaxes(Integer taxes) {
        this.taxes=taxes;
    }
	
	public Double getTotalAmount() {
        return this.totalAmount;
    }
	
	public void setTotalAmount(Double totalAmount) {
        this.totalAmount=totalAmount;
    }
	
	public String getCustomerOid() {
        return this.customerOid;
    }
	
	public void setCustomerOid(String customerOid) {
        this.customerOid=customerOid;
    }
	
    
    @Override
    public String toString() {
    	StringBuilder toStringBuilder = new StringBuilder("OrderView [");
        toStringBuilder.append("oid=").append(getOid()).append(",");
        toStringBuilder.append("version=").append(getVersion()).append(",");
        toStringBuilder.append("orderNumber=").append(getOrderNumber()).append(",");
        toStringBuilder.append("storeId=").append(getStoreId()).append(",");
        toStringBuilder.append("placementDate=").append(getPlacementDate()).append(",");
        toStringBuilder.append("deliveryDate=").append(getDeliveryDate()).append(",");
        toStringBuilder.append("orderState=").append(getOrderState()).append(",");
        toStringBuilder.append("taxes=").append(getTaxes()).append(",");
        toStringBuilder.append("totalAmount=").append(getTotalAmount()).append(",");
        toStringBuilder.append("customerOid=").append(getCustomerOid());
        return toStringBuilder.append("]").toString();
    }
}
