package org.openxma.dsl.reference.mappertest.validation;

import org.springframework.validation.Errors;
import org.openxma.dsl.platform.validation.Validators;
import org.openxma.dsl.reference.mappertest.model.Person;

@SuppressWarnings("boxing")
public abstract class PersonGenValidator extends Validators {
        
    @SuppressWarnings("unchecked")
    public boolean supports(Class clazz) {
        return Person.class.isAssignableFrom(clazz);
    }
    
    public Errors validate(Person person) {
        Errors errors = createErrors(person);      
        validate(person,errors);
        return errors;
    }

    public void validate(Object object, Errors errors) {
        Person person = (Person) object;
        rejectIfMaxLength(errors,"firstName",person.getFirstName(),25);
        rejectIfMaxLength(errors,"readOnlyName",person.getReadOnlyName(),25);
        rejectIfMaxLength(errors,"lastName",person.getLastName(),25);
        rejectIfMaxLength(errors,"emailAddress",person.getEmailAddress(),40);
    }
    
}
