package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOString</code>.
 */
public class VOString extends org.openxma.dsl.platform.valueobject.ValueObjectString {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOString(String pString) {
    	super(pString);
    }

    /**
     * Create a new instance of VOString or return null depending on input.
     */
    public static VOString newOrNull(String pString) {
        if (pString != null) {
            return new VOString(pString);
        }
        return null;
    }

}
