package org.openxma.dsl.reference.types.valueobject;

/**
 * Represents a custom DataType for <code>VOTimestamp</code>.
 */
public class VOTimestamp extends org.openxma.dsl.platform.valueobject.ValueObjectTimestamp {

    /**
     * Put the control and responsibility on the developer to determine the version of the
     * serialization class with which a serialized object is compatible.
     */
    private static final long serialVersionUID = 100L;

    /**
     * default ctor
     */
    public VOTimestamp(java.sql.Timestamp pTimestamp) {
    	super(pTimestamp);
    }

    /**
     * Create a new instance of VOTimestamp or return null depending on input.
     */
    public static VOTimestamp newOrNull(java.sql.Timestamp pTimestamp) {
        if (pTimestamp != null) {
            return new VOTimestamp(pTimestamp);
        }
        return null;
    }

}
