package org.openxma.dsl.reference.ui.panels.client;

import java.util.Locale;
import java.util.ResourceBundle;
import org.eclipse.swt.*;
import org.eclipse.swt.events.*;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;
import at.spardat.xma.component.*;
import at.spardat.xma.page.*;
import at.spardat.xma.mdl.*;

/**
 * This class implements the generic client part of ArrangedPanels.
 * It implements the widgets and models of the page.
 *
 */
public abstract class ArrangedPanelsGen extends org.openxma.dsl.platform.xma.client.DslDialogPage {
    private Locale genPageLocale = null;
    private ResourceBundle genPageMessages = null;
    Group leftTopW;
    Group leftBottomW;
    Group mittleTopW;
    Group middleW;
    Group ArrangedPanels_composite_4_0_0_0W;
    Group rightPanelW;
    Group ArrangedPanels_composite_6_0_0_0W;
    Group rightBottomW;
    WModel[] widgetModels;
    Control[] widgets;

    /**
     * Constructs the ArrangedPanelsGen.
     * @param parent the parent page
     */
    public ArrangedPanelsGen(PageClient parent) {
        super(parent,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the ArrangedPanelsGen.
     * @param component the component this page belongs to
     */
    public ArrangedPanelsGen(ComponentClient component) {
        super(component,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the ArrangedPanelsGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     */
    public ArrangedPanelsGen(ComponentClient component, Shell parentShell) {
        super(component,parentShell,false,SWT.PRIMARY_MODAL|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }

    /**
     * Constructs the ArrangedPanelsGen.
     * @param component the component this page belongs to
     * @param parentShell the shell of the calling dialog
     * @param modal the SWT-style for the desired modality
     */
    public ArrangedPanelsGen(ComponentClient component, Shell parentShell, int modal) {
        super(component,parentShell,false,modal|SWT.CLOSE|SWT.MAX|SWT.MIN|SWT.RESIZE|SWT.TITLE);
        createModels();
    }


    /*
     * returns the Locale used for this page
    */
    final protected Locale getGenPageLocale() {
        if (genPageLocale == null) {
            genPageLocale = getComponent().getContext().getLocale();
        }
        return genPageLocale;
    }

    /*
     * returns the message resource bundle used for this page
    */
    final protected ResourceBundle getGenPageMessages() {
        if (genPageMessages == null) {
            genPageMessages = ResourceBundle.getBundle("org.openxma.dsl.reference.ui.panels.client.Panels",getGenPageLocale());
        }
        return genPageMessages;
    }

    /**
     * Gives the URI of the help for this page
     * This URI is relative to the download-URI of the component
     * @return the relative URI of the help for this page
     */
    public String getHelpUri() {
        return "help/org/openxma/dsl/reference/ui/panels/ArrangedPanels.html";
    }

    /**
     * Create and initialize the WidgetModels of the page.
     * Subpages which are not lazy are created too.
     */
    public void createModels() {

        widgetModels = new WModel[] {  };
        getComponent().registerPageModel(this);
    }

    /**
     * Indicate if the WidgetModels are already created.
     * @return true if the WidgetModels exist.
     */
    public boolean hasModels() {
        return widgetModels != null;
    }

    /**
     * Remove all WidgetModels of the page.
     */
    public void removeWidgetModels() {
        widgetModels = null;
    }

    /**
     * Returns an array of all WidgetModels of this page.
     * @return array of WidgetModels. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public WModel[] getWModels() {
        return widgetModels;
    }

    /**
     * Replaces the model array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWModels(WModel[] models) {
        widgetModels=models;
    }

    /**
     * Returns a unique id to identify the type of this Page.
     * @return the typeId
     */
    public short getTypeId() {
        return Panels.ArrangedPanelsClass;
    }

    /**
     * Returns the component this page belongs to, casted to its actual type.
     * @return The Component. Never null.
     */
    public Panels getTypedComponent() {
        return (Panels) getComponent();
    }

    /**
     * Returns an array of all Widgets of this page.
     * @return array of Widgets. The returned array is not a copy, therefore
     *          it must not be modified.
     */
    public Control[] getWidgets() {
        return widgets;
    }

    /**
     * Replaces the widget array generated by guidesigner.
     * May only be called by the runtime. Do not call this method!
     */
    protected void setWidgets(Control[] widgets) {
        this.widgets=widgets;
    }

    /**
     * Create and initialize all SWT-Widgets of the page.
     * It <br>
     * <ul>
     * <li> instantiates the Widgets </li>
     * <li> sets constant texts (Title, Labels, Tooltips) and Images </li>
     * <li> registers the eventadapter </li>
     * <li> defines the Layout (Attachments, Distances, Sizes) </li>
     * <li> sets the focus </li>
     * <li> defines the Taborder </li>
     * </ul>
     */
    protected void createWidgets() {
        FormData data;
        Control[] tabOrder;
        EventAdapter adapter = new EventAdapter(this);
        final Scaler scaler = Scaler.getInstance(getComposite());

        final Shell shell = getShell();
        if(getDialog()==this) {
            shell.setText(getGenPageMessages().getString("ArrangedPanels"));
            shell.addHelpListener(adapter);
        } else {
            getComposite().addHelpListener(adapter);
        }
        Composite ArrangedPanelsCompW = getComposite();
        FormLayout layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        ArrangedPanelsCompW.setLayout(layout);

        leftTopW = new Group(ArrangedPanelsCompW,SWT.NONE);
        leftTopW.setText(getGenPageMessages().getString("ArrangedPanels.leftTopW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        leftTopW.setLayout(layout);

        leftBottomW = new Group(ArrangedPanelsCompW,SWT.NONE);
        leftBottomW.setText(getGenPageMessages().getString("ArrangedPanels.leftBottomW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        leftBottomW.setLayout(layout);

        mittleTopW = new Group(ArrangedPanelsCompW,SWT.NONE);
        mittleTopW.setText(getGenPageMessages().getString("ArrangedPanels.mittleTopW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        mittleTopW.setLayout(layout);

        middleW = new Group(ArrangedPanelsCompW,SWT.NONE);
        middleW.setText(getGenPageMessages().getString("ArrangedPanels.middleW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        middleW.setLayout(layout);

        ArrangedPanels_composite_4_0_0_0W = new Group(ArrangedPanelsCompW,SWT.NONE);
        ArrangedPanels_composite_4_0_0_0W.setText(getGenPageMessages().getString("ArrangedPanels.ArrangedPanels_composite_4_0_0_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        ArrangedPanels_composite_4_0_0_0W.setLayout(layout);

        rightPanelW = new Group(ArrangedPanelsCompW,SWT.NONE);
        rightPanelW.setText(getGenPageMessages().getString("ArrangedPanels.rightPanelW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        rightPanelW.setLayout(layout);

        ArrangedPanels_composite_6_0_0_0W = new Group(ArrangedPanelsCompW,SWT.NONE);
        ArrangedPanels_composite_6_0_0_0W.setText(getGenPageMessages().getString("ArrangedPanels.ArrangedPanels_composite_6_0_0_0W"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        ArrangedPanels_composite_6_0_0_0W.setLayout(layout);

        rightBottomW = new Group(ArrangedPanelsCompW,SWT.NONE);
        rightBottomW.setText(getGenPageMessages().getString("ArrangedPanels.rightBottomW"));
        layout = new FormLayout();
        layout.marginHeight = scaler.convertYToCurrent(3);
        layout.marginWidth = scaler.convertXToCurrent(3);
        rightBottomW.setLayout(layout);

        widgets = new Control[] { leftTopW, leftBottomW, mittleTopW, middleW, ArrangedPanels_composite_4_0_0_0W, rightPanelW, ArrangedPanels_composite_6_0_0_0W, rightBottomW };

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(30,100,scaler.convertXToCurrent(5));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(40,100,scaler.convertYToCurrent(0));
        leftTopW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(0,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(50,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(leftTopW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        leftBottomW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(leftTopW,scaler.convertXToCurrent(0),SWT.RIGHT);
        data.right = new FormAttachment(80,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(0,100,scaler.convertYToCurrent(0));
        data.bottom = new FormAttachment(25,100,scaler.convertYToCurrent(-7));
        mittleTopW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(leftTopW,scaler.convertXToCurrent(0),SWT.RIGHT);
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(mittleTopW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        data.bottom = new FormAttachment(leftBottomW,scaler.convertYToCurrent(0),SWT.TOP);
        middleW.setLayoutData(data);

        data = new FormData();
        data.height = scaler.convertYToCurrent(40);
        data.left = new FormAttachment(leftBottomW,scaler.convertXToCurrent(0),SWT.RIGHT);
        data.right = new FormAttachment(rightBottomW,scaler.convertXToCurrent(0),SWT.LEFT);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        ArrangedPanels_composite_4_0_0_0W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(leftBottomW,scaler.convertXToCurrent(0),SWT.RIGHT);
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(middleW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        data.bottom = new FormAttachment(ArrangedPanels_composite_4_0_0_0W,scaler.convertYToCurrent(0),SWT.TOP);
        rightPanelW.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(mittleTopW,scaler.convertXToCurrent(0),SWT.RIGHT);
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(leftTopW,scaler.convertYToCurrent(0),SWT.TOP);
        data.bottom = new FormAttachment(middleW,scaler.convertYToCurrent(0),SWT.TOP);
        ArrangedPanels_composite_6_0_0_0W.setLayoutData(data);

        data = new FormData();
        data.left = new FormAttachment(70,100,scaler.convertXToCurrent(0));
        data.right = new FormAttachment(100,100,scaler.convertXToCurrent(0));
        data.top = new FormAttachment(rightPanelW,scaler.convertYToCurrent(0),SWT.BOTTOM);
        data.bottom = new FormAttachment(100,100,scaler.convertYToCurrent(0));
        rightBottomW.setLayoutData(data);


        if(getDialog()==this) {
            shell.setTabList(new Control[] { ArrangedPanelsCompW });
        }
        tabOrder = new Control[8];
        tabOrder[0] = leftTopW;
        tabOrder[1] = leftBottomW;
        tabOrder[2] = mittleTopW;
        tabOrder[3] = middleW;
        tabOrder[4] = ArrangedPanels_composite_4_0_0_0W;
        tabOrder[5] = rightPanelW;
        tabOrder[6] = ArrangedPanels_composite_6_0_0_0W;
        tabOrder[7] = rightBottomW;
        ArrangedPanelsCompW.setTabList(tabOrder);
        tabOrder = new Control[0];
        leftTopW.setTabList(tabOrder);
        tabOrder = new Control[0];
        leftBottomW.setTabList(tabOrder);
        tabOrder = new Control[0];
        mittleTopW.setTabList(tabOrder);
        tabOrder = new Control[0];
        middleW.setTabList(tabOrder);
        tabOrder = new Control[0];
        ArrangedPanels_composite_4_0_0_0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        rightPanelW.setTabList(tabOrder);
        tabOrder = new Control[0];
        ArrangedPanels_composite_6_0_0_0W.setTabList(tabOrder);
        tabOrder = new Control[0];
        rightBottomW.setTabList(tabOrder);
        if(getDialog()==this) {
            shell.setSize(scaler.convertXToCurrent(640), scaler.convertYToCurrent(480));
        }
    }

    /**
     * Remove all Widgets of the page after they have been disposed.
     */
    public void removeWidgets() {
        leftTopW = null;
        leftBottomW = null;
        mittleTopW = null;
        middleW = null;
        ArrangedPanels_composite_4_0_0_0W = null;
        rightPanelW = null;
        ArrangedPanels_composite_6_0_0_0W = null;
        rightBottomW = null;
        widgets = null;
    }


    /**
     * Attaches all WidgetModels of the page to there corresponding Widgets.
     */
    public void attachUIImpl() throws AttachmentExceptionClient {
    }

    /**
     * This method will be called every time the ArrangedPanels becomes visible.
     */
    protected void enter() {
        super.enter();
    }

    /**
     * Calls the clientevent configured for the widget of the event.
     *
     * @param event the SWT-Event that happened.
     * @param type the type of the Event, as defined by the event type constants in class SWT.
     */
    protected void clientEvent(SelectionEvent event,int type) {
    }

}
